//#define _WINDOWS

// Get system provided entropy for seed initialization


#ifndef _WINDOWS
#include <fcntl.h>
#include <unistd.h>

int Get_System_Provided_Entropy(u8 *buffer, u32 buffer_size_bytes)
{
 int randomData = open("/dev/urandom", O_RDONLY);
 int size = read(randomData, (char*)buffer, buffer_size_bytes);
 close(randomData);
 return size;
}

#else

#include <windows.h>
#include <wincrypt.h>
#include "types.h"
#include "random.h"

// Returns nonzero on success

int Get_System_Provided_Entropy(u8 *buffer, u32 buffer_size_bytes)
{
HCRYPTPROV  hCryptProv;

CryptAcquireContext(&hCryptProv,NULL,NULL,PROV_RSA_FULL,0); 

int ret_value = CryptGenRandom(hCryptProv, buffer_size_bytes, buffer); 

CryptReleaseContext(hCryptProv,0);

reset_stack();

return ret_value;
}

#endif

