#ifndef FILE_TRANSFER_H
#define FILE_TRANSFER_H

#include <stdio.h>
#include "network.h"
#include "cp_strop.h"
#include "cp_threads.h"
#include "types.h"

static const u32 CHUNK_SIZE = NETWORK_SIZE_USEFUL-12;
static const u32 CHUNK_NUM = 3;

typedef struct _transfer{
	HWND hWnd;
	HANDLE file;
	tchar_t *file_name;
	u8 state;
	u32 session;
	NODE nd;
	u32 chunk[CHUNK_NUM][NETWORK_SIZE_USEFUL / sizeof(u32)];
	u32  chunk_timeout[CHUNK_NUM];
	u32 chunk_size[CHUNK_NUM];
	u64 chunk_seq[CHUNK_NUM];
	u64 chunk_total;
	u64 chunk_cur;
	u64 file_size;
	u32 timeout;
	cp_time_t start_time;
	struct _transfer* next;
} transfer_t;

class FILE_TRANSFER {
	HWND mainWnd;
	HANDLE timer;
	HANDLE stop;
	CRITICAL_SECTION cs;
	transfer_t* transfers;

	friend DWORD CALLBACK timeout_trhead(void* foo);

	transfer_t* new_transfer(void);

public:
	FILE_TRANSFER(HWND mWnd);
	~FILE_TRANSFER();

	void transfer(const NODE* nd, pctstr_t file_name);
	void parse_packet(const u32* packet, u32 size, const NODE* nd);
};

void FileTransfer(HWND hWnd, NODE *nd);
INT_PTR CALLBACK TransferProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

void file_transfer_cancel(transfer_t* tr);

#endif // FILE_TRANSFER_H
