#ifndef MAIN_H_INCLUDED
#define MAIN_H_INCLUDED
//-----------------------------------------------------------------------
#include "types.h"
#include "kademlia.h"
#include "network.h"
#include "file_transfer.h"
#include "settings.h"
//-----------------------------------------------------------------------
#define VERSION TEXT("Beta 1.2")
//-----------------------------------------------------------------------
KADEMLIA* getKad(void);
NETWORK* getNet(void);
FILE_TRANSFER* getFileTransfer(void);
SECRET_DATA* getSecretData(void);
u32 getPassword(u8* password);
void parsePacket(NET_PACKET* pac);
void appendLike(NODE* nd);
void getFileTransferPath(LPTSTR FileName);
//-----------------------------------------------------------------------
void GetMyName(LPTSTR name);
bool isTrustUser(u32* id);
void StartChat(u32* id);
//-----------------------------------------------------------------------
void setVolume(WORD value);
WORD getVolume(void);
void setMicrophone(WORD value);
WORD getMicrophone(void);
void SetWaveParam(settings_t* set);
//-----------------------------------------------------------------------
#endif //MAIN_H_INCLUDED
