#ifndef SETTINGS_H_INCLUDED
#define SETTINGS_H_INCLUDED
//-----------------------------------------------------------------------
#include "types.h"
#include "signature.h"
#include "log.h"
#include "kademlia.h"
//-----------------------------------------------------------------------
typedef struct {
	TCHAR keyFileName[MAX_PATH];
	TCHAR userFileName[MAX_PATH];
	TCHAR logFileName[MAX_PATH];
	TCHAR likesFileName[MAX_PATH];
	TCHAR ftPath[MAX_PATH];
	TCHAR microphone[MAXPNAMELEN];
	TCHAR speaker[MAXPNAMELEN];
	u32 passwordTime;
	u16 localPort;
	u16 remotePort;
	int enableUPnP;
	int enableLogFile;
	int allowAnyone;
	int allowConnection;
	int acceptFT;
} settings_t;
//-----------------------------------------------------------------------
void SettingDialog(HWND hWnd, settings_t* set, USERS* usr, KADEMLIA* kad);
void LoadSettings(HWND hWnd, settings_t* set);
void SaveSettings(HWND hWnd, settings_t* set);
void LoadNodes(HWND hWnd, LPTSTR fileName, NODE **nds, u32* size);

void SelectFile(HWND hWnd, UINT idc);
VOID URL2IP(LPCTSTR url, u32* ip);
//-----------------------------------------------------------------------
#endif //SETTINGS_H_INCLUDED
